Subject: FVWM: new behaviour in fvwm-cvs with mouse button actions ...

From: Cameron Simpson <[email-masked]>
Date: Wed, 16 Apr 2003 13:26:09 +1000

I just moved to fvwm CVS of 2003-04-16 from fvwm-2.5.6.
I have Alt-Right-Button bound to Move in a window context:

	Mouse    3 W M           Move

This used to apply on button-down, so I could go Alt-M3-drag and slide my
windows around. Not is applies on button-up, which is much less pleasant.

Can I exert control over which transition counts?
The manual doesn't suggest so to me, but perhaps I've missed something.

Cheers,
-- 
Cameron Simpson, DoD#743        [email-masked]    http://www.zip.com.au/~cs/

My mind is like a blotter: Soaks it up, gets it backwards.
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Ben Winslow <[email-masked]>
Date: 15 Apr 2003 23:44:08 -0400

> The manual doesn't suggest so to me, but perhaps I've missed something.

I encountered the same thing--the explination is basically that having
Move work this way from the mouse binding is actually a bug, and the
proper way to do it is from a function using "I" (immediate.)  Search
the message subjects for "'Move' only happens on mouse release" for the
thread where I asked about it.

I wrote a short awk script to automatically fix an fvwm2rc for the
lazy.  It's attached to the thread I mentioned, but if you can't find
that I've also put it at http://themuffin.net/fvwm-mousecmd-convert.awk

Cheers,
-- 
Ben Winslow <[email-masked]>

---

From: Cameron Simpson <[email-masked]>
Date: Wed, 16 Apr 2003 14:09:40 +1000

On 23:44 15 Apr 2003, Ben Winslow <[email-masked]> wrote:
| On Tue, 2003-04-15 at 23:26, Cameron Simpson wrote:
| > I just moved to fvwm CVS of 2003-04-16 from fvwm-2.5.6.
| > I have Alt-Right-Button bound to Move in a window context:
| > 	Mouse    3 W M           Move
| > 
| > This used to apply on button-down, so I could go Alt-M3-drag and slide my
| > windows around. Not is applies on button-up, which is much less pleasant.
| > 
| > Can I exert control over which transition counts?
| > The manual doesn't suggest so to me, but perhaps I've missed something.
| 
| I encountered the same thing--the explination is basically that having
| Move work this way from the mouse binding is actually a bug, and the
| proper way to do it is from a function using "I" (immediate.)  Search
| the message subjects for "'Move' only happens on mouse release" for the
| thread where I asked about it.
| 
| I wrote a short awk script to automatically fix an fvwm2rc for the
| lazy.  It's attached to the thread I mentioned, but if you can't find
| that I've also put it at http://themuffin.net/fvwm-mousecmd-convert.awk

Hmm.

As near as I can tell just moving the action into a function changed nothing:

	Mouse                   3 W M           Function MoveWindow

	DestroyFunc MoveWindow
	AddToFunc MoveWindow    I       Current Move

Am I completely clueless? The behaviour still obtains on mouse-release only.
-- 
Cameron Simpson, DoD#743        [email-masked]    http://www.zip.com.au/~cs/

...technology marches on - and makes 150-mph motorcycles for 15-mph
beginners' brains.	- _motorcyclist_
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Dan Espen <[email-masked]>
Date: Wed, 16 Apr 2003 00:21:53 -0400

> Am I completely clueless? The behaviour still obtains on mouse-release only.

This issue is in the todo list:

D. To be discussed
------------------

  D.2 Leave or remove the current change to triggering bindings on button press
      or release?  Seems to irritate a lot of users, but fixes a root window
      binding bug.
      [dv: added on 29-Mar-2003]

As far as I know there is only this compatibility issue between 2.4.x and
the future 2.6.  I don't think this fix is worth having to run a conversion
script.

There are some issues with using a beta.  This change may or may not remain.
Right now, I'm living with the problem rather than change my config.

-- 
Dan Espen                           E-mail: [email-masked]

---

From: Cameron Simpson <[email-masked]>
Date: Wed, 16 Apr 2003 14:49:03 +1000

On 00:21 16 Apr 2003, Dan Espen <[email-masked]> wrote:
| > Am I completely clueless? The behaviour still obtains on mouse-release only.
| 
| This issue is in the todo list:
| 
| D. To be discussed
|   D.2 Leave or remove the current change to triggering bindings on button press
|       or release?  Seems to irritate a lot of users, but fixes a root window
|       binding bug.
|       [dv: added on 29-Mar-2003]
| 
| As far as I know there is only this compatibility issue between 2.4.x and
| the future 2.6.  I don't think this fix is worth having to run a conversion
| script.
| 
| There are some issues with using a beta.  This change may or may not remain.
| Right now, I'm living with the problem rather than change my config.

Aha.

Could a comprimise be reached - support both transitions? I wouldn't
care which way the default went if I could catch either action. I can
even imagine uses for both.
-- 
Cameron Simpson, DoD#743        [email-masked]    http://www.zip.com.au/~cs/

The road is my shepherd and I shall not stop.
	- Sam Eliott, Road Hogs MTV 1993
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Dominik Vogt <[email-masked]>
Date: Wed, 16 Apr 2003 09:07:50 +0200

> 	AddToFunc MoveWindow    I       Current Move
                                        ^^^^^^^

This is wrong.  It may even move a different window than you click
on.  Try

  AddToFunc MoveWindow    I Move

> Am I completely clueless? The behaviour still obtains on mouse-release only.

Bye

Dominik ^_^  ^_^

---

From: Dominik Vogt <[email-masked]>
Date: Wed, 16 Apr 2003 09:10:31 +0200

> even imagine uses for both.

Unfortunately, triggering actions and selecting windows with the
mouse is very tricky.  I can't think of a feasible way to have
Move, Resize etc. work on button press and not break them on the
root window.

Bye

Dominik ^_^  ^_^

---

From: Cameron Simpson <[email-masked]>
Date: Thu, 17 Apr 2003 13:05:24 +1000

On 09:10 16 Apr 2003, Dominik Vogt <[email-masked]> wrote:
| On Wed, Apr 16, 2003 at 02:49:03PM +1000, Cameron Simpson wrote:
| > On 00:21 16 Apr 2003, Dan Espen <[email-masked]> wrote:
| > |   D.2 Leave or remove the current change to triggering bindings on button press
| > |       or release?  Seems to irritate a lot of users, but fixes a root window
| > |       binding bug.
| > |       [dv: added on 29-Mar-2003]
| > | As far as I know there is only this compatibility issue between 2.4.x and
| > | the future 2.6.  I don't think this fix is worth having to run a conversion
| > | script. [...]
| > Could a comprimise be reached - support both transitions? I wouldn't
| > care which way the default went if I could catch either action. I can
| > even imagine uses for both.
| 
| Unfortunately, triggering actions and selecting windows with the
| mouse is very tricky.  I can't think of a feasible way to have
| Move, Resize etc. work on button press and not break them on the
| root window.

Could you tell me what source file I should read to start examining this?

>From your email I have some idea of the issue now. However, for the
user the (desired) behaviour seems well defined with no weird cases,
so I might take a look at the stuff underneath.
-- 
Cameron Simpson, DoD#743        [email-masked]    http://www.zip.com.au/~cs/

So the master hit the novice upside the head with the back of his hand.
"Why did you do that!?"  "I do not want to have to learn another editor."
And the student was enlightened.	- Larry Colen <[email-masked]>
--
Visit the official FVWM web page at <URL: http://www.fvwm.org/>.
To unsubscribe from the list, send "unsubscribe fvwm" in the body of a
message to [email-masked].
To report problems, send mail to [email-masked].

---

From: Dominik Vogt <[email-masked]>
Date: Thu, 17 Apr 2003 10:38:07 +0200

> Could you tell me what source file I should read to start examining this?

It's an interaction between the code in HandleButtonPress
(events.c), the code in functions.c and the execution context code
(execcontext.c).  You may also want to take a loot at functable.c.

> so I might take a look at the stuff underneath.

It might be easier to explain your idea and let me see how it can
be implemented :-)  Command execution is perhaps the most
complicated thing inside fvwm.  Of course it is possible to learn
how it works, but that process takes a lot of time.

Bye

Dominik ^_^  ^_^